#ifndef SCHEDULE_H_INCLUDED
#define SCHEDULE_H_INCLUDED

#include "pc6001v.h"
#include "device.h"
#include "ini.h"
#include "SThread.h"

#include "p6device.h"

// 祤٥ȿ
#define	MAXEVENT	(32)


// ٥ȥե饰
// bit0: ֤ؼ
#define	EV_ONETIME	(0x00)	/* 󥿥 */
#define	EV_LOOP		(0x01)	/* 롼 */
// bit1,2: ñ
#define	EV_HZ		(0x00)	/* Hz */
#define	EV_US		(0x02)	/* us */
#define	EV_MS		(0x04)	/* ms */
#define	EV_STATE	(0x08)	/* CPUơȿ */


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cSche {
public:
	// ٥Ⱦ¤
	typedef struct {
		P6DEVENT* device;	// ٥ȥǥХ֥ȥݥ
		int id;				// ٥ID
		BOOL Active;		// ٥ͭե饰 TRUE:ͭ FALSE:
		int Period;			// 1Υå
		int Clock;			// Ĥꥯå
		double nps;			// ٥ȯȿ(Hz)
	} evinfo;
	
protected:
	evinfo ev[MAXEVENT];	// ٥Ⱦ
	
	int MasterClock;		// ޥå(ŪˤCPUơȿ/äˤʤϤ)
	
	int NextEvent;			// Υ٥ȤȯޤǤΥå
	int SaveCloclk;			// åί
	
	// ®ٷ׻
	DWORD WRClock;			// å¸(¬λ)
	DWORD WRClockTmp;		// å¸(¬)
	
	evinfo *Find( P6DEVENT *, int );			// ٥ȸ
	void SetMasterClock( int );					// ޥå
	
public:
	cSche();									// 󥹥ȥ饯
	virtual ~cSche();							// ǥȥ饯
	
	BOOL Add( P6DEVENT *, int, double, int );	// ٥ɲ
	BOOL Del( P6DEVENT *, int );				// ٥Ⱥ
	
	BOOL SetHz( P6DEVENT *, int, double );		// ٥ȯȿ
	
	void Update( int );							// ٥ȹ
	void Reset( P6DEVENT *, int );				// ꥤ٥ȤꥻåȤ
	
	int Rest( P6DEVENT *, int );				// ٥ȯޤǤλĤꥯå
	double Scale( P6DEVENT *, int );			// ٥ȤοʹΨ
	
	BOOL GetEvinfo( evinfo * );					// ٥Ⱦ
	BOOL SetEvinfo( evinfo * );					// ٥Ⱦ
};

class SCH6 : public P6DEVICE, public cSche, public SThread, public IDoko {
protected:
	int CpuClock;			// CPUå(Hz)
	SDL_sem *WaitSem;		// Waitޥե
	BOOL WaitEnable;		// Waitͭե饰
	BOOL VSYNC;				// VSYNCե饰 TRUE:VSYNCã FALSE:ãƤʤ
	int EnableScrUpdate;	// ̹ե饰
	
	void OnThread( void * );					// åɴؿ
	
public:
	SCH6( VM6 *, const P6ID& );					// 󥹥ȥ饯
	virtual ~SCH6();							// ǥȥ饯
	
	BOOL Init( int );							// 
//	void CalcCpuState();						// ̤ɽ֤˱CPUơȿ׻
	
	BOOL Start();								// ư
	void Stop();								// ư
	
	BOOL GetWaitEnable();						// Waitͭե饰
	void SetWaitEnable( BOOL );					// Waitͭե饰
	
	BOOL IsVSYNC(){ return VSYNC; }				// VSYNCã?
	void OnVSYNC(){ VSYNC = TRUE; }				// VSYNCΤ
	void VWait();								// VSYNC Wait
	void WaitReset();							// Wait
	
	int GetRatio();								// ¹®
	
	int GetClock(){ return CpuClock; }			// CPUå
	
	BOOL IsScreenUpdate();						// ̹ޤ?
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};

#endif	// SCHEDULE_H_INCLUDED
