#include <string.h>
#include <stdio.h>

#include "tape.h"
#include "common.h"
#include "disk.h"
#include "global.h"
#include "intr.h"
#include "mc6847.h"
#include "keyboard.h"
#include "pd8049.h"
#include "schedule.h"


// P6TեޥåVer.2
//  Ūˤϡ֥٥᡼+եå+٥᡼(4byte)פȤ¤
//  եåˤDATA֥å󤬴ޤޤ롣
//  DATA֥å̵ڤȤ1ȿ롣
//  BASICʤɡ֥إåܥǡפȤ¤ξ硤DATA֥å2ĤȤʤ뤬
//  IDֹƱˤ뤳ȤǴϢդƴǤ롣
//
// [եå]
//  header (2byte) : "P6"
//  ver    (1byte) : С
//  dbnum  (1byte) : ޤޤDATA֥å(255Ĥޤ)
//  start  (1byte) : ȥȥե饰(0:̵ 1:ͭ)
//  basic  (1byte) : BASIC⡼(PC-6001ξ̵̣)
//  page   (1byte) : ڡ
//  askey  (2byte) : ȥȥޥʸ
//  ...ޥɤϤθaskeyʬ³
//  exhead (2byte) : ĥ󥵥(64KBޤ)
//  ...ĥ󤬤Ϥθexheadʬ³
//
// [DATA֥å]
//  header (2byte) : "TI"
//  id     (1byte) : IDֹ(DATA֥åϢդ)
//  name  (16byte) : ǡ̾(15ʸ+'00H')
//  baud   (2byte) : ܡ졼(600/1200)
//  stime  (2byte) : ̵λ(ms)
//  ptime  (2byte) : ԡλ(ms)
//  offset (4byte) : ٥᡼ƬΥեå
//  size   (4byte) : ǡ


// ٥ID
#define	EID_TAPE	(1)

// ȿ
#define PG_HI	(0)
#define PG_LO	(1)

////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
CMTL::CMTL( VM6 *vm, const ID& id ) : P6DEVENT(vm,id), Device(id)
{
	*FilePath  = '\0';
	p6t        = NULL;
	Relay      = FALSE;
	Boost      = DEFAULT_BOOST;
	MaxBoost60 = DEFAULT_MAXBOOST60;
	MaxBoost62 = DEFAULT_MAXBOOST62;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
CMTL::~CMTL( void )
{
	Unmount();
}


////////////////////////////////////////////////////////////////
// ٥ȥХåؿ
//
// :	id		٥ID
//			clock	å
// :	ʤ
////////////////////////////////////////////////////////////////
void CMTL::EventCallback( int id, int clock )
{
	switch( id ){
	case EID_TAPE:	// CMT߽
		// ߽Ǥʤ?
		if( vm->subcpu->IsCmtIntrReady() ){
			// CMTåץǡ
			WORD rd = Update();
			// ǡʤCMTȯ
			if( rd & PG_D ){
				vm->subcpu->ReqCmtIntr( rd & 0xff );
			}
		}
		break;
	}
}


////////////////////////////////////////////////////////////////
// ⡼(PLAY,STOP)
////////////////////////////////////////////////////////////////
BOOL CMTL::Remote( BOOL relay )
{
    PRINTD1( TAPE_LOG, "[TAPE][Relay] -> %s\n", relay ? "TRUE" : "FALSE" );
	
	// 졼ξ֤¸
	Relay = relay;
	
	// 졼ξ֤ˤꥤ٥ɲor
	if( relay ){	// ON
		// ̥ˤBoostUpΨ
		// BASIC⡼(N60,N60m/N66)ˤäȽǤ٤
		// ޤ긷̩ǤϤʤɤȤˤ
		int bst = Boost ? ( vm->vdg->GetWinSize() ? MaxBoost60 : MaxBoost62 ) : 1;
		
		if( IsMount() ) p6t->SetBoost( bst );
		
		if( !vm->sche->Add( this, EID_TAPE, DEFAULT_CMT_HZ * bst, EV_LOOP|EV_HZ ) ) return FALSE;
	}else{			// OFF
		if( !vm->sche->Del( this, EID_TAPE ) ) return FALSE;
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
BOOL CMTL::Init( void )
{
	// P6T ΰ(ꥻåȻˤ̵)
	p6t = NULL;
	
	// ȥ꡼³
	vm->snd->ConnectStream( (cRing *)this );
	
	// TAPE˥
	SndDev::Volume = DEFAULT_TAPEVOL;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ꥻå
////////////////////////////////////////////////////////////////
void CMTL::Reset( void )
{
	// TAPEꥻå
	if( p6t ) p6t->Reset();
}


////////////////////////////////////////////////////////////////
// ȥʸ
////////////////////////////////////////////////////////////////
void CMTL::SetAutoStart( int model )
{
	// ȥͭ?
	if( p6t && p6t->GetStart() ){
		char buf[256] = "";
		
		// Хåե˽
		switch( model ){
		case 60:	// PC-6001
			sprintf( buf, "%c%c", p6t->GetPage()+'0', 0x0d );
			break;
		case 62:	// PC-6001mk2
			switch( p6t->GetBASIC() ){
			case 3:
			case 4:
			case 5:
				if( vm->disk->GetDrives() )	// ??? ºݤ?
					sprintf( buf, "%c%c%c%c%c%c%c%c%c%c", 0x17, 50, p6t->GetBASIC()+'0', 0x17, 20, 0x0d, p6t->GetPage()+'0', 0x0d, 0x17, 110 );
				else
					sprintf( buf, "%c%c%c%c%c%c%c%c%c",   0x17, 50, p6t->GetBASIC()+'0', 0x17, 20,       p6t->GetPage()+'0', 0x0d, 0x17, 110 );
				break;
			default:
				sprintf( buf, "%c%c%c%c%c%c%c%c%c", 0x17, 50, p6t->GetBASIC()+'0', 0x17, 20, p6t->GetPage()+'0', 0x0d, 0x17, 10 );
			}
			break;
		case 66:	// PC-6601
			switch( p6t->GetBASIC() ){
			case 3:
			case 4:
			case 5:
				if( vm->disk->IsMount( 0 ) )
					sprintf( buf, "%c%c%c%c%c%c%c%c%c%c", 0x17, 50, p6t->GetBASIC()+'0', 0x17, 20, 0x0d, p6t->GetPage()+'0', 0x0d, 0x17, 110 );
				else
					sprintf( buf, "%c%c%c%c%c%c%c%c%c",   0x17, 50, p6t->GetBASIC()+'0', 0x17, 20,       p6t->GetPage()+'0', 0x0d, 0x17, 110 );
				break;
			default:
				sprintf( buf, "%c%c%c%c%c%c%c%c%c", 0x17, 50, p6t->GetBASIC()+'0', 0x17, 20, p6t->GetPage()+'0', 0x0d, 0x17, 10 );
			}
			break;
//		case 64:	// PC-6001mk2SR
//		case 68:	// PC-6601SR
		}
		memcpy( &buf[strlen(buf)], p6t->GetAutoStartStr(), p6t->GetAutoStartLen() );
		
		// ư
		if( vm->key->SetAutoKey( buf, strlen(buf) ) );
	}
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
BOOL CMTL::Mount( char *filename )
{
	PRINTD1( TAPE_LOG, "[TAPE][Mount] %s\n", filename  );
	
	// ⤷ޥȺѤߤǤХޥȤ
	if( p6t ){
		delete p6t;
		p6t = NULL;
	}
	
	// P6T
	p6t = new cP6T;
	if( !p6t ) return FALSE;
	
	// ե뤫ɹ
	if( !p6t->Readf( filename ) ){
		delete p6t;
		p6t = NULL;
		return FALSE;
	}
	
	// եѥ¸
	strncpy( FilePath, filename, PATH_MAX );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
void CMTL::Unmount( void )
{
	PRINTD( TAPE_LOG, "[TAPE][Unmount]\n" );
	
	if( p6t ){
		delete p6t;
		p6t = NULL;
		*FilePath = '\0';
	}
}


////////////////////////////////////////////////////////////////
// CMT 1ʸɹ
// ̤͡ϥǡ(ԡ,̵,ǡ) ̤ϥǡ
// 졼ON & CMT OPEN 
////////////////////////////////////////////////////////////////
WORD CMTL::CmtRead( void )
{
	PRINTD( TAPE_LOG, "[TAPE][CmtRead] " );
	
	// TAPEޥȤƤʤ̵
	if( !p6t ) return PG_S;
	
	// ̵Ԥ?
	if( p6t->IsSWaiting() ){
		PRINTD( TAPE_LOG, "swait\n" );
		return PG_S;
	}
	
	// ԡԤ?
	if( p6t->IsPWaiting() ){
		PRINTD( TAPE_LOG, "pwait\n" );
		return PG_P;
	}
	
	// ǡɹ
	PRINTD( TAPE_LOG, "read\n" );
	return PG_D | p6t->ReadOne();
}


////////////////////////////////////////////////////////////////
// ޥȺѤ?
////////////////////////////////////////////////////////////////
BOOL CMTL::IsMount( void )
{
	if( p6t ) return TRUE;
	else      return FALSE;
}


////////////////////////////////////////////////////////////////
// ȥ?
////////////////////////////////////////////////////////////////
BOOL CMTL::IsAutoStart( void )
{
	if( p6t ) return p6t->GetStart();
	else      return FALSE;
}


////////////////////////////////////////////////////////////////
// եѥ
////////////////////////////////////////////////////////////////
char *CMTL::GetFile()
{
	return FilePath;
}


////////////////////////////////////////////////////////////////
// TAPE̾
////////////////////////////////////////////////////////////////
char *CMTL::GetName( void )
{
	if( p6t ) return p6t->GetName();
	else      return "";
}


////////////////////////////////////////////////////////////////
// ٥᡼
////////////////////////////////////////////////////////////////
DWORD CMTL::GetSize( void )
{
	if( p6t ) return p6t->GetSize();
	else      return 0;
}


////////////////////////////////////////////////////////////////
// 󥿼
////////////////////////////////////////////////////////////////
int CMTL::GetCount( void )
{
	if( p6t ) return p6t->GetCount();
	else      return 0;
}


////////////////////////////////////////////////////////////////
// 졼ξּ
////////////////////////////////////////////////////////////////
BOOL CMTL::IsRelay( void )
{
	return Relay;
}


////////////////////////////////////////////////////////////////
// BoostUp
////////////////////////////////////////////////////////////////
void CMTL::SetBoost( BOOL boost )
{
	if( Boost != boost ){
		Boost = boost;
		// 졼ONäöߤƺƳ
		if( Relay ){
			Remote( FALSE );
			Remote( TRUE );
		}
	}
}


////////////////////////////////////////////////////////////////
// BoostUpΨ
////////////////////////////////////////////////////////////////
void CMTL::SetMaxBoost( int max60, int max62 )
{
	if( max60 > 0 ) MaxBoost60 = max60;
	if( max62 > 0 ) MaxBoost62 = max62;
}


////////////////////////////////////////////////////////////////
// BoostUpּ
////////////////////////////////////////////////////////////////
BOOL CMTL::IsBoostUp( void )
{
	return Boost;
}


////////////////////////////////////////////////////////////////
// ȥ꡼๹
////////////////////////////////////////////////////////////////
WORD CMTL::Update( void )
{
	PRINTD( TAPE_LOG, "[TAPE][Update]\n" );
	
	WORD rd = PG_S;
	
	// TAPE᡼ץ?
	if( p6t ){
		// 1byteʬΥǡ 10ms()
		int length = vm->snd->GetSampleRate() / DEFAULT_CMT_HZ;
		int bdata;
		
		rd = CmtRead();		// CMT 1ʸɹ
		
		switch( rd & 0xff00 ){	// ǡϡ
		case PG_P:	// ԡξ
			// ⲻ˥å
			while( length-- ) SndDev::cRing::Put( GetSinCurve( PG_HI ) );
			
			break;
		case PG_S:	// ̵ξ
			while( length-- ) SndDev::cRing::Put( 0 );
			
			break;
		case PG_D:	// ǡξ
			// ȥӥå 1bit
			// ǡӥå   8bits
			// ȥåץӥå 3bits
			
			bdata = length/12;	// 1bitΥǡ
			// ȥӥå
			for( int i=0; i<bdata; i++ ){
				SndDev::cRing::Put( GetSinCurve( PG_LO ) );
			}
			// ǡӥå
			for( int j=7; j>=0; j-- ){
				int hilo = (rd>>j)&1 ? PG_HI : PG_LO;
				for( int i=0; i<bdata; i++ ){
					SndDev::cRing::Put( GetSinCurve( hilo ) );
				}
			}
			// ȥåץӥå
			for( length -= bdata*9; length > 0; length-- ){
				SndDev::cRing::Put( GetSinCurve( PG_HI ) );
			}
			break;
		}
	}
	
	return rd;
}


////////////////////////////////////////////////////////////////
// sinȼ
////////////////////////////////////////////////////////////////
int CMTL::GetSinCurve( int fq )
{
	static const int sinc[] = {
		     0,   5690,  11207,  16384,  21062,  25101,  28377,  30791,  32269,
		 32767,  32269,  30791,  28377,  25101,  21062,  16384,  11207,   5690,
		     0,  -5690, -11207, -16384, -21062, -25101, -28377, -30791, -32269,
		-32767, -32269, -30791, -28377, -25101, -21062, -16384, -11207,  -5690
	};
	static int n=0;
	
	// ץ󥰥졼ȤȼȿǴְδֳ֤
	// ǡơ֥44100Hz,1200Hzο
	n += (fq == PG_HI ? 2:1 ) * DEFAULT_SAMPLE_RATE / vm->snd->GetSampleRate();
	
	// ơ֥륵72(sizeof(sinc))
	if( n >= (int)(sizeof(sinc)/sizeof(int)) ) n -= (int)(sizeof(sinc)/sizeof(int));
	
	int ret = ( sinc[n] * SndDev::Volume ) / 100;
	
	// ⲻ㲻ǲ̥٥뤬㤦餷(1.32)
//	if( fq == PG_HI ) ret = (int)((double)ret/(double)1.32);
	if( fq == PG_HI ) ret -= ret / 4;	// ۤ1/1.32
	
	return ret;
}




////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
CMTS::CMTS( VM6 *vm, const P6ID& id ) : P6DEVENT(vm,id)
{
	fp   = NULL;
	Baud = 1200;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
CMTS::~CMTS( void )
{
	Unmount();
}


////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////
//BOOL CMTS::Init( void )
//{
//	return TRUE;
//}

BOOL CMTS::Init( char *filename )
{
	if( *filename ){
		// եѥ¸
		strncpy( FilePath, filename, PATH_MAX );
	}
	return TRUE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
//BOOL CMTS::Mount( char *filename )
//{
//	if( fp ) fclose( fp );
//	
//	fp = FOPENEN( filename, "wb" );
//	
//	if( fp ){
//		// եѥ¸
//		strncpy( FilePath, filename, PATH_MAX );
//		return TRUE;
//	}else
//		return FALSE;
//}

BOOL CMTS::Mount( void )
{
	if( fp ) fclose( fp );
	
	fp = FOPENEN( FilePath, "wb" );
	
	if( fp ) return TRUE;
	else     return FALSE;
}


////////////////////////////////////////////////////////////////
// TAPEޥ
////////////////////////////////////////////////////////////////
void CMTS::Unmount( void )
{
	if( fp ){
		// եåդ(Ȥꤢ٥)
		fflush( fp );
		int beta = ftell( fp );	// ٥᡼
		
		// [եå]
		fputc( 'P', fp );	// header (2byte) : "P6"
		fputc( '6', fp );
		fputc( 2, fp );		// ver    (1byte) : С
		fputc( 1, fp );		// dbnum  (1byte) : ޤޤDATA֥å(255Ĥޤ)
		fputc( 0, fp );		// start  (1byte) : ȥȥե饰(0:̵ 1:ͭ)
		fputc( 1, fp );		// basic  (1byte) : BASIC⡼(PC-6001ξ̵̣)
		fputc( 1, fp );		// page   (1byte) : ڡ
		fputc( 0, fp );		// askey  (2byte) : ȥȥޥʸ
		fputc( 0, fp );		// ...ޥɤϤθaskeyʬ³
		fputc( 0, fp );		// exhead (2byte) : ĥ󥵥(64KBޤ)
		fputc( 0, fp );		// ...ĥ󤬤Ϥθexheadʬ³
		
		// [DATA֥å]
		fputc( 'T', fp );				// header (2byte) : "TI"
		fputc( 'I', fp );
		fputc( 0, fp );					// id     (1byte) : IDֹ(DATA֥åϢդ)
		for( int i=0; i<16; i++ ) fputc( 0, fp );	// name  (16byte) : ǡ̾(15ʸ+'00H')
		FPUTWORD( Baud, fp );			// baud   (2byte) : ܡ졼(600/1200)
		fputc( 0x48, fp );				// stime  (2byte) : ̵λ(ms)
		fputc( 0x0d, fp );
		fputc( 0x48, fp );				// ptime  (2byte) : ԡλ(ms)
		fputc( 0x0d, fp );
		fputc( 0, fp );					// offset (4byte) : ٥᡼ƬΥեå
		fputc( 0, fp );
		fputc( 0, fp );
		fputc( 0, fp );
		FPUTDWORD( beta, fp );			// size   (4byte) : ǡ
		
		// [٥᡼]
		FPUTDWORD( beta, fp );
		
		fclose( fp );
		fp = NULL;
		*FilePath = '\0';
	}
}


////////////////////////////////////////////////////////////////
// ܡ졼
////////////////////////////////////////////////////////////////
void CMTS::SetBaud( int b )
{
	Baud = b;
}


////////////////////////////////////////////////////////////////
// CMT 1ʸ
////////////////////////////////////////////////////////////////
void CMTS::CmtWrite( BYTE data )
{
	if( fp ) fputc( data, fp );
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
////////////////////////////////////////////////////////////////
BOOL CMTL::DokoSave( cIni *Ini )
{
	cSche::evinfo e;
	char stren[16];
	
	e.device = this;
	
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "TAPE", NULL, "Relay",	"%s",	Relay ? "Yes" : "No" );
	Ini->PutEntry( "TAPE", NULL, "BoostUp",	"%s",	Boost ? "Yes" : "No" );
	
	// ٥
	e.id = EID_TAPE;
	if( vm->sche->GetEvinfo( &e ) ){
		sprintf( stren, "Event%08X", e.id );
		Ini->PutEntry( "TAPE", NULL, stren, "%d %d %d %lf", e.Active ? 1 : 0, e.Period, e.Clock, e.nps );
	}
	
	// TAPEޥȤƤʤв⤷ʤ
	if( !p6t ) return TRUE;
	
	// ޥȤƤP6T֥ȤSAVE
	Ini->PutEntry( "TAPE", NULL, "FilePath",	"%s",	FilePath );
	
	return p6t->DokoSave( Ini );
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
////////////////////////////////////////////////////////////////
BOOL CMTL::DokoLoad( cIni *Ini )
{
	int yn;
	cSche::evinfo e;
	char stren[16];
	char strrs[64];
	
	e.device = this;
	
	if( !Ini ) return FALSE;
	
	Ini->GetTruth( "TAPE", "Relay",		&Relay,	Relay );
	Ini->GetTruth( "TAPE", "BoostUp",	&Boost,	Boost );
	
	// ٥
	e.id = EID_TAPE;
	sprintf( stren, "Event%08X", e.id );
	if( Ini->GetString( "TAPE", stren, strrs, "" ) ){
		sscanf( strrs,"%d %d %d %lf", &yn, &e.Period, &e.Clock, &e.nps );
		e.Active = yn ? TRUE : FALSE;
		if( !vm->sche->SetEvinfo( &e ) ) return FALSE;
	}
	
	Ini->GetString( "TAPE", "FilePath", FilePath, "" );
	if( *FilePath ){
		if( !Mount( FilePath ) ) return FALSE;
		if( !p6t->DokoLoad( Ini ) ) return FALSE;
	}else
		Unmount();
	
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
//  device description
////////////////////////////////////////////////////////////////
const Device::Descriptor CMTL::descriptor = {
	CMTL::indef, CMTL::outdef
};

const Device::OutFuncPtr CMTL::outdef[] = {
	STATIC_CAST( Device::OutFuncPtr, &CMTL::OutB0H )
};

const Device::InFuncPtr CMTL::indef[] = {};
