#ifndef Z80_H_INCLUDED
#define Z80_H_INCLUDED

#include <SDL_endian.h>

#include "pc6001v.h"
#include "ini.h"

#include "p6device.h"


// ڥ쥸 ǡ
typedef union {
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
 	struct { BYTE h,l; } B;
#else
	struct { BYTE l,h; } B;
#endif
			 WORD        W;
} PAIR;

// 쥸 ¤
struct Register {
	PAIR AF, BC, DE, HL;	// ѥ쥸
	PAIR IX, IY, PC, SP;	// ѥ쥸
	PAIR AF1,BC1,DE1,HL1;	//  ΢ 쥸
	BYTE I, R;				// ü쥸
	BYTE R_saved;			// R reg ¸
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// ⡼
	BYTE Halt;				// HALT ե饰
};


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class cz80 : public IDoko {
protected:
	typedef signed char	offset;
	
	PAIR AF, BC, DE, HL;	// ѥ쥸
	PAIR IX, IY, PC, SP;	// ѥ쥸
	PAIR AF1,BC1,DE1,HL1;	//  ΢ 쥸
	BYTE I, R;				// ü쥸
	BYTE R_saved;			// R reg ¸
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// ⡼
	BYTE Halt;				// HALT ե饰
	
	int mstate;				// ꥢ ơȿ
	
	// եå(M1)
	virtual BYTE Fetch( WORD, int * )   = 0;
	
	// ꥢ(Ȥʤ)
	virtual BYTE ReadMemNW( WORD )      = 0;
	
	// ꥢ(Ȥ)
	virtual BYTE ReadMem( WORD )        = 0;
	virtual void WriteMem( WORD, BYTE ) = 0;
	
	// I/Oݡȥ
	virtual BYTE ReadIO( int )          = 0;
	virtual void WriteIO( int, BYTE )   = 0;
	
	// ߥ٥
	virtual int GetIntrVector()         = 0;
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	void PrintfHead( char *, WORD, int );	// ɥ쥹/󥹥ȥ饯󥳡ɤɽ
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
public:
	cz80();						// 󥹥ȥ饯
	virtual ~cz80();			// ǥȥ饯
	
	void Reset();				// ꥻå
	int Exec();					// 1̿¹
	
	void AddWait( int );		// ɲ
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// ǥХå
	int Disasm( char *, WORD );		// 1饤ե֥
	void GetRegister( Register * );	// 쥸ͼ
	void SetRegister( Register * );	// 쥸
	WORD GetPC(){ return PC.W; }	// PC쥸ͼ
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};


class CPU6 : public P6DEVICE, public cz80 {
private:
	// եå(M1)
	inline BYTE Fetch( WORD, int * );
	
	// ꥢ(Ȥʤ)
	inline BYTE ReadMemNW( WORD );
	
	// ꥢ(Ȥ)
	inline BYTE ReadMem( WORD );
	inline void WriteMem( WORD, BYTE );
	
	// I/Oݡȥ
	inline BYTE ReadIO( int );
	inline void WriteIO( int, BYTE );
	
	// ߥ٥
	inline int GetIntrVector();
	
public:
	CPU6( VM6 *, const P6ID& );	// 󥹥ȥ饯
	~CPU6();					// ǥȥ饯
	
	BOOL Init();				// 
};

#endif		// Z80_H_INCLUDED
